package com.junmp.jyzb.controller;

import com.junmp.jyzb.api.bean.dto.InventorySumDto;
import com.junmp.jyzb.api.bean.dto.TjDto.*;
import com.junmp.jyzb.api.bean.query.TjReq.TjOrgCountReq;
import com.junmp.jyzb.api.bean.query.TjReq.TjOrgEqsReq;
import com.junmp.jyzb.api.bean.query.TjReq.TjOrgPoliceReq;
import com.junmp.jyzb.api.bean.query.TjReq.TjOrgPriceReq;
import com.junmp.jyzb.api.bean.query.WarehouseReq;
import com.junmp.jyzb.entity.Temp.HumidityAndtemperature;
import com.junmp.jyzb.service.TjService;
import com.junmp.jyzb.service.WarehouseService;
import com.junmp.v2.common.bean.request.ValidationApi;
import com.junmp.v2.common.bean.response.ApiRes;
import com.junmp.v2.db.api.page.PageResult;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

@RestController
@Slf4j
@RequestMapping("/Tj")
@Api(tags = "[报表]统计报表模块")
public class TjController {

   @Resource
   private TjService tjService;

    @Resource
    public WarehouseService warehouseService;

    /**
     * ------------------------------------装备统计报表--------------------------------------------
     */


    /**
  * 根据组织机构统计装备的报表数据（外层数据）
  */
    @PostMapping("/GetTjData")
    @ApiOperation("/装备统计报表")
    public ApiRes<PageResult<TjOrgEqsDto>> GetTjData(@RequestBody TjOrgEqsReq req){
        return ApiRes.success(tjService.GetTjData(req));
    }

    @PostMapping("/TjOrgDataSum")
    @ApiOperation("/装备统计报表汇总")
    public ApiRes<FinalTjOrgEqsDto> TjOrgDataSum(@RequestBody TjOrgEqsReq req){
        return ApiRes.success(tjService.TjOrgDataSum(req));
    }


    //第二层数据
    @PostMapping("/TjOrgEqsDetail")
    @ApiOperation("装备统计报表二层数据")
    public ApiRes<List<TjOrgEqsDto>> TjOrgEqsDetail(@RequestBody TjOrgEqsReq req){
        return ApiRes.success(tjService.GetTjDataDetail(req));
    }
    @PostMapping("/TjOrgEqsDetailList")
    @ApiOperation("/查询组织机构下的装备统计明细列表")
    public ApiRes<List<InventorySumDto>> TjOrgEqsDetailList(@RequestBody TjOrgEqsReq req){
        return ApiRes.success(tjService.TjOrgEqsDetailList(req));
    }

    @PostMapping(path="/TjOrgEqsExport",name="装备报表导出#logType=30")
    @ApiOperation("装备报表导出")
    public void TjOrgEqsExport(@RequestBody TjOrgEqsReq req){
     tjService.TjOrgEqsExport(req);
    }


    /**
     *-------------------------------------财务统计报表------------------------------------------
     */

    //财务统计报表
    @PostMapping("/TjOrgPrice")
    @ApiOperation("/财务统计报表")
    public ApiRes<PageResult<TjOrgPriceDto>> TjOrgPrice(@RequestBody TjOrgPriceReq req){
        PageResult<TjOrgPriceDto> tjOrgPriceDtoPageResult = tjService.TjOrgPrice(req);
        return ApiRes.success(tjOrgPriceDtoPageResult);
    }
    @PostMapping("/TjOrgPriceSum")
    @ApiOperation("/财务统计报表汇总")
    public ApiRes<FinalTjOrgPriceDto> TjOrgPriceSum(@RequestBody TjOrgPriceReq req){
        return ApiRes.success(tjService.TjOrgPriceSum(req));
    }

    @PostMapping("/TjOrgPriceDetail")
    @ApiOperation("/查询组织机构下的财务统计明细")
    public ApiRes<List<TjOrgPriceDto>> TjOrgPriceDetail(@RequestBody TjOrgPriceReq req){
     return ApiRes.success(tjService.TjOrgPriceDetail(req));
    }

    @PostMapping("/TjOrgPriceDetail1")
    @ApiOperation("/查询组织机构下的财务统计明细二层结构(改)")
    public ApiRes<List<TjOrgPriceDto>> TjOrgPriceDetail1(@RequestBody TjOrgPriceReq req){
        return ApiRes.success(tjService.TjOrgPriceDetail1(req));
    }


    @PostMapping("/TjOrgPriceDetailList")
    @ApiOperation("/查询组织机构下的财务统计明细(改)")
    public ApiRes<List<TjOrgPriceDto>> TjOrgPriceDetailList(@RequestBody TjOrgPriceReq req){
        return ApiRes.success(tjService.TjOrgPriceDetailList(req));
    }


    @PostMapping(path="/TjOrgPriceExport",name="财务报表导出#logType=30")
    @ApiOperation("财务报表导出")
    public void TjOrgPriceExport(@RequestBody TjOrgPriceReq req){
        tjService.TjOrgPriceExport(req);
    }


    /**
     * --------------------------------------使用统计报表-------------------------------------------
     */

    @PostMapping("/TjOrgCount")
    @ApiOperation("/使用统计报表")
    public ApiRes<PageResult<TjOrgCountDto>> TjOrgCount(@RequestBody @Validated(ValidationApi.detail.class) TjOrgCountReq req){
        return ApiRes.success(tjService.TjOrgCount(req));
    }
    @PostMapping("/TjOrgCountSum")
    @ApiOperation("/使用统计报表汇总")
    public ApiRes<FinalTjOrgCountDto> TjOrgCountSum(@RequestBody @Validated(ValidationApi.detail.class) TjOrgCountReq req){
        return ApiRes.success(tjService.TjOrgCountSum(req));
    }

   @PostMapping("/TjOrgCountDetail")
   @ApiOperation("/查询组织机构下的使用统计明细")
   public ApiRes<List<TjOrgCountDto>> TjOrgPriceDetail(@RequestBody TjOrgCountReq req){
    return ApiRes.success(tjService.TjOrgCountDetail(req));
   }
    @PostMapping("/TjOrgCountDetail1")
    @ApiOperation("/查询组织机构下的使用统计明细")
    public ApiRes<List<TjOrgCountDto>> TjOrgPriceDetail1(@RequestBody TjOrgCountReq req){
        return ApiRes.success(tjService.TjOrgCountDetail1(req));
    }


    @PostMapping("/TjOrgCountDetailList")
    @ApiOperation("/查询组织机构下的使用统计明细")
    public ApiRes<List<TjOrgCountDto>> TjOrgCountDetailList(@RequestBody TjOrgCountReq req){
        return ApiRes.success(tjService.TjOrgCountDetailList(req));
    }

    //首页使用柱状图
    @PostMapping("/TjOrgCountByType")
    @ApiOperation("九大类使用统计柱状图")
    public ApiRes<List<TjOrgCountDto>> TjOrgCountByType(@RequestBody TjOrgCountReq req){
        return ApiRes.success(tjService.TjOrgCountByType(req));
    }

    //首页出入库统计
    @PostMapping("/TjOutAndInCount")
    @ApiOperation("首页出入库统计")
    public ApiRes<List<TjOutAndInDto>> TjOutAndInCount(@RequestBody @Validated(ValidationApi.list.class) TjOrgCountReq req){
        return ApiRes.success(tjService.TjOutAndInCount(req));
    }

    @PostMapping(path="/TjOrgCountExport",name="使用报表导出#logType=30")
    @ApiOperation("使用报表导出")
    public void TjOrgCountExport(@RequestBody TjOrgCountReq req){
     tjService.TjOrgCountExport(req);
    }

    /**
     * --------------------------------------人员统计报表-------------------------------------------
     */
    @PostMapping("/TjOrgPolice")
    @ApiOperation("/人员统计报表")
    public ApiRes<PageResult<TjOrgPoliceDto>> TjOrgPolice(@RequestBody TjOrgPoliceReq req){
        return ApiRes.success(tjService.TjOrgPolice(req));
    }
    @PostMapping("/TjOrgPoliceSum")
    @ApiOperation("/人员统计报表汇总")
    public ApiRes<FinalTjOrgPoliceDto> TjOrgPoliceSum(@RequestBody TjOrgPoliceReq req){
        return ApiRes.success(tjService.TjOrgPoliceSum(req));
    }

    @PostMapping("/TjOrgPoliceDetailList")
    @ApiOperation("/查询组织机构下的人员统计明细")
    public ApiRes<List<TjOrgPoliceDto>> TjOrgPoliceDetailList(@RequestBody TjOrgPoliceReq req){
        return ApiRes.success(tjService.TjOrgPoliceDetailList(req));
    }

   @PostMapping(path="/TjOrgPoliceExport",name="人员报表导出#logType=30")
   @ApiOperation("人员报表导出")
   public void TjOrgPoliceExport(@RequestBody TjOrgPoliceReq req){
    tjService.TjOrgPoliceExport(req);
   }


    /**
     * --------------------------------------温湿度记录-------------------------------------------
     */

    @PostMapping("/showHumidityAndtemperature")
    @ApiOperation("展示温湿度记录")
    public ApiRes<List<HumidityAndtemperature>> showHumidityAndtemperature(@RequestBody WarehouseReq req){
        return ApiRes.success(warehouseService.showHumidityAndtemperature(req));
    }

    @PostMapping(path="/HumidityAndtemperatureExport",name="温湿度报表导出#logType=30")
    @ApiOperation("温湿度报表导出")
    public void HumidityAndtemperatureExport(@RequestBody WarehouseReq req){
        warehouseService.HumidityAndtemperatureExport(req);
    }




    @PostMapping("/test")
    public ApiRes<FinalTjOrgEqsDto> test(@RequestBody TjOrgEqsReq req){
        return ApiRes.success(tjService.test(req));
    }


//    @PostMapping("test")
//    public ApiRes<List<TjOrgEqsDto>> test(@RequestBody InventoryReq req){
//        return ApiRes.success(tjService.test(req));
//    }
}
